## rust-wasmtime 16.0.0+dfsg

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(wasmtime-examples)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_CXX_STANDARD 11)

add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/../crates/c-api ${CMAKE_CURRENT_BINARY_DIR}/wasmtime)

function(CREATE_TARGET TARGET TARGET_PATH)
	add_executable(wasmtime-${TARGET} ${TARGET_PATH})

	if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
		target_compile_options(wasmtime-${TARGET} PRIVATE -Wall -Wextra -Wno-deprecated-declarations)
	elseif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
		target_compile_options(wasmtime-${TARGET} PRIVATE /W3)
	endif()

	set_target_properties(wasmtime-${TARGET} PROPERTIES
		OUTPUT_NAME wasmtime-${TARGET}
		RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/$<0:>
		CXX_VISIBILITY_PRESET hidden
		POSITION_INDEPENDENT_CODE ON)

	target_include_directories(wasmtime-${TARGET} PUBLIC wasmtime)
	target_link_libraries(wasmtime-${TARGET} PUBLIC wasmtime)
	add_test(NAME ${TARGET}-c COMMAND $<TARGET_FILE:wasmtime-${TARGET}> WORKING_DIRECTORY ../..)
endfunction()

function(CREATE_RUST_TEST EXAMPLE)
	if(ARGC GREATER 1)
		add_test(NAME ${EXAMPLE}-rust COMMAND cargo run --example ${EXAMPLE} --features ${ARGV1} WORKING_DIRECTORY ../..)
	else()
		add_test(NAME ${EXAMPLE}-rust COMMAND cargo run --example ${EXAMPLE} WORKING_DIRECTORY ../..)
	endif()
endfunction()
function(CREATE_RUST_WASM EXAMPLE TARGET)
	execute_process(COMMAND cargo build -p example-${EXAMPLE}-wasm --target ${TARGET})
endfunction()

# Enable testing
enable_testing()

# Add all examples
create_target(async async.cpp)
create_target(externref externref.c)
create_target(fib-debug fib-debug/main.c)
create_target(fuel fuel.c)
create_target(gcd gcd.c)
create_target(hello hello.c)
create_target(interrupt interrupt.c)
create_target(linking linking.c)
create_target(memory memory.c)
create_target(multi multi.c)
create_target(multimemory multimemory.c)
create_target(serialize serialize.c)
create_target(threads threads.c)
create_target(wasi wasi/main.c)

# Add rust tests
create_rust_wasm(fib-debug wasm32-unknown-unknown)
create_rust_wasm(tokio wasm32-wasi)
create_rust_wasm(wasi wasm32-wasi)
create_rust_test(epochs)
create_rust_test(externref)
create_rust_test(fib-debug)
create_rust_test(fuel)
create_rust_test(gcd)
create_rust_test(hello)
create_rust_test(interrupt)
create_rust_test(linking)
create_rust_test(memory)
create_rust_test(multi)
create_rust_test(multimemory)
create_rust_test(serialize)
create_rust_test(threads)
create_rust_test(wasi)
create_rust_test(tokio wasmtime-wasi/tokio)

=== crates/c-api/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

set(WASMTIME_USER_CARGO_BUILD_OPTIONS "" CACHE STRING "Additional cargo flags (such as --features) to apply to the build command")
option(BUILD_SHARED_LIBS "Build using shared libraries" OFF)
option(WASMTIME_ALWAYS_BUILD "If cmake should always invoke cargo to build wasmtime" ON)

if(CMAKE_BUILD_TYPE STREQUAL "Release")
	set(WASMTIME_BUILD_TYPE_FLAG "--release")
	set(WASMTIME_BUILD_TYPE "release")
else()
	set(WASMTIME_BUILD_TYPE "debug")
endif()

if(BUILD_SHARED_LIBS)
	# Copy shared library into build directory
	if(WIN32)
		set(WASMTIME_INSTALL_COMMAND ${CMAKE_COMMAND} -E copy_if_different
			${CMAKE_CURRENT_SOURCE_DIR}/../../target/${WASMTIME_BUILD_TYPE}/wasmtime.dll
			${CMAKE_BINARY_DIR})
	elseif(APPLE)
		set(WASMTIME_INSTALL_COMMAND ${CMAKE_COMMAND} -E copy_if_different
			${CMAKE_CURRENT_SOURCE_DIR}/../../target/${WASMTIME_BUILD_TYPE}/libwasmtime.dylib
			${CMAKE_BINARY_DIR})
	else()
		set(WASMTIME_INSTALL_COMMAND ${CMAKE_COMMAND} -E copy_if_different
			${CMAKE_CURRENT_SOURCE_DIR}/../../target/${WASMTIME_BUILD_TYPE}/libwasmtime.so
			${CMAKE_BINARY_DIR})
	endif()
endif()

if(ANDROID)
	# TODO wasmtime only supports arm64-v8a right now
	if(ANDROID_ABI STREQUAL "armeabi-v7a")
		set(ANDROID_TARGET "armv7-linux-androideabi")
		set(ANDROID_ARCH_SHORT "arm")
	elseif(ANDROID_ABI STREQUAL "arm64-v8a")
		set(ANDROID_TARGET "aarch64-linux-android")
		set(ANDROID_ARCH_SHORT "aarch64")
	elseif(ANDROID_ABI STREQUAL "x86")
		set(ANDROID_TARGET "i686-linux-android")
		set(ANDROID_ARCH_SHORT "i386")
	elseif(ANDROID_ABI STREQUAL "x86_64")
		set(ANDROID_TARGET "x86_64-linux-android")
		set(ANDROID_ARCH_SHORT "x86_64")
	endif()

	set(WASMTIME_BUILD_TARGET "--target=${ANDROID_TARGET}")
endif()

if (BUILD_SHARED_LIBS AND ANDROID)
	message(FATAL_ERROR "Wasmtime cannot be built with BUILD_SHARED_LIBS on Android")
endif()

if(BUILD_SHARED_LIBS)
	if(WIN32)
		set(WASMTIME_BUILD_PRODUCT
			${CMAKE_CURRENT_SOURCE_DIR}/../../target/${WASMTIME_BUILD_TYPE}/wasmtime.dll.lib)
	elseif(APPLE)
		set(WASMTIME_BUILD_PRODUCT
			${CMAKE_CURRENT_SOURCE_DIR}/../../target/${WASMTIME_BUILD_TYPE}/libwasmtime.dylib)
	else()
		set(WASMTIME_BUILD_PRODUCT
			${CMAKE_CURRENT_SOURCE_DIR}/../../target/${WASMTIME_BUILD_TYPE}/libwasmtime.so)
	endif()
else()
	if(WIN32)
		set(WASMTIME_BUILD_PRODUCT
			${CMAKE_CURRENT_SOURCE_DIR}/../../target/${WASMTIME_BUILD_TYPE}/wasmtime.lib)
	elseif(ANDROID)
		set(WASMTIME_BUILD_PRODUCT
			${CMAKE_CURRENT_SOURCE_DIR}/../../target/${ANDROID_TARGET}/${WASMTIME_BUILD_TYPE}/libwasmtime.a)
	else()
		set(WASMTIME_BUILD_PRODUCT
			${CMAKE_CURRENT_SOURCE_DIR}/../../target/${WASMTIME_BUILD_TYPE}/libwasmtime.a)
	endif()
endif()

if(ANDROID)
	# Rust attempts to use libgcc.a on NDK versions r23-beta3 and up
	# but it has been replaced with libunwind.a (rust-lang/rust#85806)
	file(WRITE ${CMAKE_BINARY_DIR}/libgcc.a "INPUT(-lunwind)")
	# The version of the clang compiler is part of the libunwind.a path
	file(STRINGS ${ANDROID_TOOLCHAIN_ROOT}/AndroidVersion.txt CLANG_VERSION_FILE)
	list(GET CLANG_VERSION_FILE 0 CLANG_VERSION)

	# Some crates use the compiler directly, environment variables
	# are set to make them use the Android compiler
	set(WASMTIME_PREBUILD_COMMAND ${CMAKE_COMMAND} -E env
	CC=${ANDROID_TOOLCHAIN_ROOT}/bin/clang
	AR=${ANDROID_TOOLCHAIN_ROOT}/bin/llvm-ar
	"RUSTFLAGS=-L ${CMAKE_SYSROOT}/usr/lib/${ANDROID_TARGET}/${ANDROID_NATIVE_API_LEVEL} \
		-L ${ANDROID_TOOLCHAIN_ROOT}/lib64/clang/${CLANG_VERSION}/lib/linux/${ANDROID_ARCH_SHORT} \
		-L ${CMAKE_BINARY_DIR} -C linker=${ANDROID_TOOLCHAIN_ROOT}/bin/ld")
endif()
include(ExternalProject)
find_program(WASMTIME_CARGO_BINARY cargo)
ExternalProject_Add(
	wasmtime-crate
	DOWNLOAD_COMMAND ""
	CONFIGURE_COMMAND ""
	INSTALL_COMMAND "${WASMTIME_INSTALL_COMMAND}"
        BUILD_COMMAND ${WASMTIME_PREBUILD_COMMAND} ${WASMTIME_CARGO_BINARY} build ${WASMTIME_BUILD_TYPE_FLAG} ${WASMTIME_USER_CARGO_BUILD_OPTIONS} ${WASMTIME_BUILD_TARGET}
	BINARY_DIR ${CMAKE_CURRENT_SOURCE_DIR}/artifact
        BUILD_ALWAYS ${WASMTIME_ALWAYS_BUILD}
	BUILD_BYPRODUCTS ${WASMTIME_BUILD_PRODUCT})
add_library(wasmtime INTERFACE)
add_dependencies(wasmtime wasmtime-crate)

if(BUILD_SHARED_LIBS)
	if(NOT WIN32)
		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-rpath='$ORIGIN'")
	endif()
	target_link_libraries(wasmtime INTERFACE ${WASMTIME_BUILD_PRODUCT})
else()
	if(WIN32)
		target_compile_options(wasmtime INTERFACE -DWASM_API_EXTERN= -DWASI_API_EXTERN=)
		target_link_libraries(wasmtime INTERFACE ${WASMTIME_BUILD_PRODUCT}
			ws2_32 advapi32 userenv ntdll shell32 ole32 bcrypt)
	elseif(APPLE OR ANDROID)
		target_link_libraries(wasmtime INTERFACE ${WASMTIME_BUILD_PRODUCT})
	else()
		target_link_libraries(wasmtime INTERFACE ${WASMTIME_BUILD_PRODUCT}
			pthread dl m)
	endif()
endif()

target_include_directories(wasmtime INTERFACE ${CMAKE_CURRENT_SOURCE_DIR}/include
	${CMAKE_CURRENT_SOURCE_DIR}/wasm-c-api/include)

include(GNUInstallDirs)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/include/wasmtime.h
	${CMAKE_CURRENT_SOURCE_DIR}/include/wasi.h
	${CMAKE_CURRENT_SOURCE_DIR}/include/doc-wasm.h
	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/wasm-c-api/include/wasm.h
	${CMAKE_CURRENT_SOURCE_DIR}/wasm-c-api/include/wasm.hh
	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/wasmtime
	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(FILES ${WASMTIME_BUILD_PRODUCT}
	DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== crates/fuzzing/wasm-spec-interpreter/ocaml/Makefile ===
# Build a library allowing FFI access to the Wasm spec interpreter.

OCAML_FLAGS := -g -keep-locs -runtime-variant _pic
# By default, we build in a sub-directory but we can override this with `make
# BUILD_DIR=...`.
BUILD_DIR := _build
# Currently the WebAssembly spec interpreter is buried in a Git submodule as is
# its build directory, `_build`. Cargo may not like that files are changing
# outside of `target` (TODO).
SPEC_DIR := spec/interpreter
SPEC_BUILD_DIR := $(SPEC_DIR)/_build
SPEC_LIB := $(SPEC_BUILD_DIR)/wasm.cmxa

# A space-separated list of paths that the linker will use to search for libgmp.
# Override with `make LIBGMP_PATHS=...`.
LIBGMP_PATHS ?= /usr/lib /usr/lib/x86_64-linux-gnu /lib64

PKGS = zarith

# Build and package the static library, `libinterpret.a`.
$(BUILD_DIR)/libinterpret.a: $(BUILD_DIR)/interpret.lib.o
	ar qs $@ $^
$(BUILD_DIR)/interpret.lib.o: $(SPEC_LIB) $(BUILD_DIR)/interpret.cmx
	ocamlfind ocamlopt $(OCAML_FLAGS) -I $(SPEC_BUILD_DIR) -o $@ -output-complete-obj $^ -linkpkg $(PKGS:%=-package %) -cclib "$(LIBGMP_PATHS:%=-L%)"
$(BUILD_DIR)/interpret.cmx: interpret.ml $(SPEC_BUILD_DIR) $(BUILD_DIR)
	ocamlfind ocamlopt $(OCAML_FLAGS) -I $(SPEC_BUILD_DIR) -o $@ -c -impl $< -linkpkg $(PKGS:%=-package %)
$(BUILD_DIR):
	mkdir -p $@


# We also need to be able to build the spec's `wasm.cmxa`.
$(SPEC_LIB):
	make -C $(SPEC_DIR) libopt


clean:
	rm -rf $(BUILD_DIR)
	make -C $(SPEC_DIR) clean

## rust-wasmtime 10.0.1+dfsg

=== debian/changelog ===
rust-wasmtime (10.0.1+dfsg-6) unstable; urgency=medium

  * really fix autopkgtest feature names
  * update dh-cargo fork

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 25 Aug 2023 22:39:58 +0200

rust-wasmtime (10.0.1+dfsg-5) unstable; urgency=medium

  * fix autopkgtest feature names

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 24 Aug 2023 11:36:10 +0200

rust-wasmtime (10.0.1+dfsg-4) unstable; urgency=medium

  * update dh-cargo fork
  * drop patch 2001_arbitrary, obsoleted by Debian package changes
  * rename patch 2001_capstone -> 1001_capstone;
    relax patch 2001_hashbrown;
    update DEP-3 patch headers

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 20 Aug 2023 16:47:33 +0200

rust-wasmtime (10.0.1+dfsg-3) experimental; urgency=medium

  * fix: embed crate cranelift-codegen-meta

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 31 Jul 2023 13:02:10 +0200

rust-wasmtime (10.0.1+dfsg-2) experimental; urgency=medium

  * update dh-cargo fork
  * update DEP-3 patch headers

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 31 Jul 2023 12:18:25 +0200

rust-wasmtime (10.0.1+dfsg-1) experimental; urgency=medium

  * initial packaging release;
    closes: bug#1041434

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 19 Jul 2023 09:14:41 +0200

=== debian/control ===
Source: rust-wasmtime
Section: rust
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-cargo,
 librust-criterion-0.5+default-dev <!nocheck>,
 librust-criterion-0.5+html-reports-dev <!nocheck>,
 librust-tempfile-3+default-dev <!nocheck>,
 librust-anyhow-1+default-dev <!nocheck>,
 librust-arbitrary-1+default-dev <!nocheck>,
 librust-bincode-1+default-dev <!nocheck>,
 librust-bumpalo-3+default-dev <!nocheck>,
 librust-capstone-0.11+default-dev <!nocheck>,
 librust-gimli-0.27+read-dev <!nocheck>,
 librust-gimli-0.27+std-dev <!nocheck>,
 librust-gimli-0.27+write-dev <!nocheck>,
 librust-hashbrown-0.12+default-dev <!nocheck>,
 librust-hashbrown-0.12+raw-dev <!nocheck>,
 librust-log-0.4-dev <!nocheck>,
 librust-regalloc2-0.9+checker-dev <!nocheck>,
 librust-regalloc2-0.9+default-dev <!nocheck>,
 librust-serde-1+default-dev <!nocheck>,
 librust-serde-1+derive-dev <!nocheck>,
 librust-sha2-0.10+default-dev <!nocheck>,
 librust-similar-2+default-dev <!nocheck>,
 librust-smallvec-1+default-dev <!nocheck>,
 librust-smallvec-1+union-dev <!nocheck>,
 librust-souper-ir-2+default-dev <!nocheck>,
 librust-target-lexicon-0.12+std-dev <!nocheck>,
 libstring-shellquote-perl <!nocheck>,
Maintainer: Jonas Smedegaard <dr@jones.dk>
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/debian/rust-wasmtime.git
Vcs-Browser: https://salsa.debian.org/debian/rust-wasmtime
Homepage: https://wasmtime.dev/
Rules-Requires-Root: no

Package: librust-cranelift-dev
Architecture: all
Multi-Arch: foreign
Depends:
 librust-anyhow-1+default-dev,
 librust-arbitrary-1+default-dev,
 librust-bincode-1+default-dev,
 librust-bumpalo-3+default-dev,
 librust-capstone-0.11+default-dev,
 librust-codespan-reporting-0.11+default-dev,
 librust-gimli-0.27+read-dev,
 librust-gimli-0.27+std-dev,
 librust-gimli-0.27+write-dev,
 librust-hashbrown-0.12+default-dev,
 librust-hashbrown-0.12+raw-dev,
 librust-log-0.4-dev,
 librust-regalloc2-0.9+checker-dev,
 librust-regalloc2-0.9+default-dev,
 librust-serde-1+default-dev,
 librust-serde-1+derive-dev,
 librust-sha2-0.10+default-dev,
 librust-smallvec-1+default-dev,
 librust-smallvec-1+union-dev,
 librust-souper-ir-2+default-dev,
 librust-target-lexicon-0.12+std-dev,
 ${misc:Depends},
Provides:
 librust-cranelift-0.97+core-dev (= ${binary:Version}),
 librust-cranelift-0.97+default-dev (= ${binary:Version}),
 librust-cranelift-0.97+std-dev (= ${binary:Version}),
 librust-cranelift-0.97-dev (= ${binary:Version}),
 librust-cranelift-0.97.1-dev (= ${binary:Version}),
 librust-cranelift-bforest-0.97+default-dev (= ${binary:Version}),
 librust-cranelift-bforest-0.97-dev (= ${binary:Version}),
 librust-cranelift-bforest-0.97.1-dev (= ${binary:Version}),
 librust-cranelift-codegen-0.97+default-dev (= ${binary:Version}),
 librust-cranelift-codegen-0.97-dev (= ${binary:Version}),
 librust-cranelift-codegen-0.97.1-dev (= ${binary:Version}),
 librust-cranelift-codegen-meta-0.97+default-dev (= ${binary:Version}),
 librust-cranelift-codegen-meta-0.97-dev (= ${binary:Version}),
 librust-cranelift-codegen-meta-0.97.1-dev (= ${binary:Version}),
 librust-cranelift-codegen-shared-0.97+default-dev (= ${binary:Version}),
 librust-cranelift-codegen-shared-0.97-dev (= ${binary:Version}),
 librust-cranelift-codegen-shared-0.97.1-dev (= ${binary:Version}),
 librust-cranelift-control-0.97+chaos-dev (= ${binary:Version}),
 librust-cranelift-control-0.97+default-dev (= ${binary:Version}),
 librust-cranelift-control-0.97-dev (= ${binary:Version}),
 librust-cranelift-control-0.97.1-dev (= ${binary:Version}),
 librust-cranelift-entity-0.97+default-dev (= ${binary:Version}),
 librust-cranelift-entity-0.97+enable-serde-dev (= ${binary:Version}),
 librust-cranelift-entity-0.97-dev (= ${binary:Version}),
 librust-cranelift-entity-0.97.1-dev (= ${binary:Version}),
 librust-cranelift-frontend-0.97+core-dev (= ${binary:Version}),
 librust-cranelift-frontend-0.97+default-dev (= ${binary:Version}),
 librust-cranelift-frontend-0.97+std-dev (= ${binary:Version}),
 librust-cranelift-frontend-0.97-dev (= ${binary:Version}),
 librust-cranelift-frontend-0.97.1-dev (= ${binary:Version}),
 librust-cranelift-isle-0.97+default-dev (= ${binary:Version}),
 librust-cranelift-isle-0.97+logging-dev (= ${binary:Version}),
 librust-cranelift-isle-0.97+fancy-errors-dev (= ${binary:Version}),
 librust-cranelift-isle-0.97-dev (= ${binary:Version}),
 librust-cranelift-isle-0.97.1-dev (= ${binary:Version}),
Description: low-level retargetable code generator - Rust source code
 Cranelift is a low-level retargetable code generator.
 It translates a target-independent intermediate representation
 into executable machine code.
 .
 This package contains the source for the Rust cranelift crate,
 for use with cargo and dh-cargo.

=== debian/tests/control ===
Test-Command: /usr/share/cargo/bin/cargo-auto-test cranelift 0.97.1
 --all-targets --all-features
Features: test-name=cranelift-0.97:@
Depends:
 dh-cargo,
 librust-criterion-0.5+default-dev,
 librust-criterion-0.5+html-reports-dev,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
 librust-cranelift-0.97-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/cargo/bin/cargo-auto-test cranelift 0.97.1
 --all-targets --no-default-features
Features: test-name=cranelift-0.97:
Depends:
 dh-cargo,
 librust-criterion-0.5+default-dev,
 librust-criterion-0.5+html-reports-dev,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
 librust-cranelift-0.97-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/cargo/bin/cargo-auto-test cranelift 0.97.1
 --all-targets --no-default-features --features core
Features: test-name=cranelift-0.97:core
Depends:
 dh-cargo,
 librust-criterion-0.5+default-dev,
 librust-criterion-0.5+html-reports-dev,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
 librust-cranelift-0.97+core-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/cargo/bin/cargo-auto-test cranelift 0.97.1
 --all-targets
Features: test-name=cranelift-0.97:default
Depends:
 dh-cargo,
 librust-criterion-0.5+default-dev,
 librust-criterion-0.5+html-reports-dev,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
 librust-cranelift-0.97+default-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/cargo/bin/cargo-auto-test cranelift 0.97.1
 --all-targets --no-default-features --features std
Features: test-name=cranelift-0.97:std
Depends:
 dh-cargo,
 librust-criterion-0.5+default-dev,
 librust-criterion-0.5+html-reports-dev,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
 librust-cranelift-0.97+std-dev,
Restrictions: allow-stderr

## rust-wasmtime 16.0.0%2Bdfsg

=== debian/rules ===
#!/usr/bin/make -f

# resolve DEB_VERSION
include /usr/share/dpkg/pkg-info.mk

# use local fork of debcargo and dh-cargo
PATH := $(CURDIR)/debian/dh-cargo/bin:$(PATH)
PERL5LIB = $(CURDIR)/debian/dh-cargo/lib
export PATH PERL5LIB

%:
	dh $@ --buildsystem cargo --sourcedirectory cranelift/umbrella

# unlock dependencies during build
execute_before_dh_auto_configure:
	[ -f Cargo.lock.orig ] || mv Cargo.lock Cargo.lock.orig

override_dh_gencontrol:
	$(eval cranelift_version = $(shell grep -Po 'version\W+\K[^"]+' cranelift/umbrella/Cargo.toml)+$(DEB_VERSION))
	dh_gencontrol -plibrust-cranelift-dev -- -v'$(cranelift_version)'
	dh_gencontrol --remaining-packages

# avoid cleaning unless source is patched
override_dh_auto_clean:
	grep -q crates/wasi-common/WASI/ Cargo.toml || dh_auto_clean

# re-lock dependencies
execute_after_dh_auto_clean:
	[ ! -f Cargo.lock.orig ] || mv -f Cargo.lock.lock Cargo.lock

## rust-wasmtime 16.0.0+dfsg

=== debian/changelog ===
rust-wasmtime (16.0.0+dfsg-3) unstable; urgency=medium

  * relax (build-)dependency for crate hashbrown;
    closes: bug#1064015, thanks to Peter Green

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 17 Feb 2024 02:40:47 +0100

rust-wasmtime (16.0.0+dfsg-2) unstable; urgency=medium

  * no-changes source-only upload to enable testing migration

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 01 Jan 2024 16:01:24 +0100

rust-wasmtime (16.0.0+dfsg-1) experimental; urgency=medium

  * update patches
  * bump project versions in virtual packages and autopkgtests

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 30 Dec 2023 17:07:52 +0100

rust-wasmtime (15.0.1+dfsg-4) unstable; urgency=medium

  * update dh-cargo fork

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 30 Dec 2023 16:30:00 +0100

rust-wasmtime (15.0.1+dfsg-3) unstable; urgency=medium

  * add patch 2001_gimli to accept older branch of crate gimli;
    relax (build-)dependency for crate gimli
  * temporarily hack local dh-cargo wrapper
    to gracefully handle crate resolving failures

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 30 Dec 2023 12:21:43 +0100

rust-wasmtime (15.0.1+dfsg-2) experimental; urgency=medium

  * (build-)depend on rustfmt

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 30 Dec 2023 11:39:48 +0100

rust-wasmtime (15.0.1+dfsg-1) experimental; urgency=medium

  * drop patches 2001_arbitrary 2001_target-lexicon,
    obsoleted by Debian package changes;
    tighten (build-)dependency on package for crate target-lexicon;
    closes: bug#1057198, thanks to Peter Green
  * update patches
  * bump project version in virtual packages and autopkgtests

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 30 Dec 2023 10:10:12 +0100

rust-wasmtime (15.0.0+dfsg-3) experimental; urgency=medium

  * add patches 2001_* to accept older releases
    of crates arbitrary regalloc2 target-lexicon

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 27 Nov 2023 14:19:37 +0100

rust-wasmtime (15.0.0+dfsg-2) experimental; urgency=medium

  * bump (build-)dependencies for crate gimli;
    closes: bug#1056924, thanks to Peter Michael Green

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 27 Nov 2023 13:15:17 +0100

rust-wasmtime (15.0.0+dfsg-1) unstable; urgency=medium

  [ upstream ]
  * new release(s)

  [ Jonas Smedegaard ]
  * update and unfuzz patches
  * update dh-cargo fork
  * update copyright info: update coverage
  * bump project version in virtual packages and autopkgtests

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 26 Nov 2023 21:14:22 +0100

rust-wasmtime (10.0.1+dfsg-7) unstable; urgency=medium

  * skip autopkgtests
    for official architectures unsupported by crate cranelift-codegen

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 31 Aug 2023 21:47:13 +0200

=== debian/control ===
Source: rust-wasmtime
Section: rust
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-cargo,
 librust-criterion-0.5+default-dev <!nocheck>,
 librust-criterion-0.5+html-reports-dev <!nocheck>,
 librust-tempfile-3+default-dev <!nocheck>,
 librust-anyhow-1+default-dev <!nocheck>,
 librust-arbitrary-1+default-dev <!nocheck>,
 librust-bincode-1+default-dev <!nocheck>,
 librust-bumpalo-3+default-dev <!nocheck>,
 librust-capstone-0.11+default-dev <!nocheck>,
 librust-gimli-dev (<< 0.29) <!nocheck>,
 librust-hashbrown-dev (<< 0.15) <!nocheck>,
 librust-log-0.4-dev <!nocheck>,
 librust-regalloc2-0.9+checker-dev <!nocheck>,
 librust-regalloc2-0.9+default-dev <!nocheck>,
 librust-serde-1+default-dev <!nocheck>,
 librust-serde-1+derive-dev <!nocheck>,
 librust-sha2-0.10+default-dev <!nocheck>,
 librust-similar-2+default-dev <!nocheck>,
 librust-smallvec-1+default-dev <!nocheck>,
 librust-smallvec-1+union-dev <!nocheck>,
 librust-souper-ir-2+default-dev <!nocheck>,
 librust-target-lexicon-0.12+std-dev (>= 0.12.12) <!nocheck>,
 libstring-shellquote-perl <!nocheck>,
 rustfmt <!nocheck>,
Maintainer: Jonas Smedegaard <dr@jones.dk>
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/debian/rust-wasmtime.git
Vcs-Browser: https://salsa.debian.org/debian/rust-wasmtime
Homepage: https://wasmtime.dev/
Rules-Requires-Root: no

Package: librust-cranelift-dev
Architecture: all
Multi-Arch: foreign
Depends:
 librust-anyhow-1+default-dev,
 librust-arbitrary-1+default-dev,
 librust-bincode-1+default-dev,
 librust-bumpalo-3+default-dev,
 librust-capstone-0.11+default-dev,
 librust-codespan-reporting-0.11+default-dev,
 librust-gimli-dev (<< 0.29),
 librust-hashbrown-dev (<< 0.15),
 librust-log-0.4-dev,
 librust-regalloc2-0.9+checker-dev,
 librust-regalloc2-0.9+default-dev,
 librust-serde-1+default-dev,
 librust-serde-1+derive-dev,
 librust-sha2-0.10+default-dev,
 librust-smallvec-1+default-dev,
 librust-smallvec-1+union-dev,
 librust-souper-ir-2+default-dev,
 librust-target-lexicon-0.12+std-dev (>= 0.12.12),
 rustfmt,
 ${misc:Depends},
Provides:
 librust-cranelift-0.103+core-dev (= ${binary:Version}),
 librust-cranelift-0.103+default-dev (= ${binary:Version}),
 librust-cranelift-0.103+std-dev (= ${binary:Version}),
 librust-cranelift-0.103-dev (= ${binary:Version}),
 librust-cranelift-0.103.0-dev (= ${binary:Version}),
 librust-cranelift-bforest-0.103+default-dev (= ${binary:Version}),
 librust-cranelift-bforest-0.103-dev (= ${binary:Version}),
 librust-cranelift-bforest-0.103.0-dev (= ${binary:Version}),
 librust-cranelift-codegen-0.103+default-dev (= ${binary:Version}),
 librust-cranelift-codegen-0.103-dev (= ${binary:Version}),
 librust-cranelift-codegen-0.103.0-dev (= ${binary:Version}),
 librust-cranelift-codegen-meta-0.103+default-dev (= ${binary:Version}),
 librust-cranelift-codegen-meta-0.103-dev (= ${binary:Version}),
 librust-cranelift-codegen-meta-0.103.0-dev (= ${binary:Version}),
 librust-cranelift-codegen-shared-0.103+default-dev (= ${binary:Version}),
 librust-cranelift-codegen-shared-0.103-dev (= ${binary:Version}),
 librust-cranelift-codegen-shared-0.103.0-dev (= ${binary:Version}),
 librust-cranelift-control-0.103+chaos-dev (= ${binary:Version}),
 librust-cranelift-control-0.103+default-dev (= ${binary:Version}),
 librust-cranelift-control-0.103-dev (= ${binary:Version}),
 librust-cranelift-control-0.103.0-dev (= ${binary:Version}),
 librust-cranelift-entity-0.103+default-dev (= ${binary:Version}),
 librust-cranelift-entity-0.103+enable-serde-dev (= ${binary:Version}),
 librust-cranelift-entity-0.103-dev (= ${binary:Version}),
 librust-cranelift-entity-0.103.0-dev (= ${binary:Version}),
 librust-cranelift-frontend-0.103+core-dev (= ${binary:Version}),
 librust-cranelift-frontend-0.103+default-dev (= ${binary:Version}),
 librust-cranelift-frontend-0.103+std-dev (= ${binary:Version}),
 librust-cranelift-frontend-0.103-dev (= ${binary:Version}),
 librust-cranelift-frontend-0.103.0-dev (= ${binary:Version}),
 librust-cranelift-isle-0.103+default-dev (= ${binary:Version}),
 librust-cranelift-isle-0.103+logging-dev (= ${binary:Version}),
 librust-cranelift-isle-0.103+fancy-errors-dev (= ${binary:Version}),
 librust-cranelift-isle-0.103-dev (= ${binary:Version}),
 librust-cranelift-isle-0.103.0-dev (= ${binary:Version}),
Description: low-level retargetable code generator - Rust source code
 Cranelift is a low-level retargetable code generator.
 It translates a target-independent intermediate representation
 into executable machine code.
 .
 This package contains the source for the Rust cranelift crate,
 for use with cargo and dh-cargo.

=== debian/tests/control ===
Test-Command: /usr/share/cargo/bin/cargo-auto-test cranelift 0.103.0
 --all-targets --all-features
Features: test-name=cranelift-0.103:@
Architecture: !armel !armhf !ppc64el !s390x
Depends:
 dh-cargo,
 librust-criterion-0.5+default-dev,
 librust-criterion-0.5+html-reports-dev,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
 librust-cranelift-0.103-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/cargo/bin/cargo-auto-test cranelift 0.103.0
 --all-targets --no-default-features
Features: test-name=cranelift-0.103:
Architecture: !armel !armhf !ppc64el !s390x
Depends:
 dh-cargo,
 librust-criterion-0.5+default-dev,
 librust-criterion-0.5+html-reports-dev,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
 librust-cranelift-0.103-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/cargo/bin/cargo-auto-test cranelift 0.103.0
 --all-targets --no-default-features --features core
Features: test-name=cranelift-0.103:core
Architecture: !armel !armhf !ppc64el !s390x
Depends:
 dh-cargo,
 librust-criterion-0.5+default-dev,
 librust-criterion-0.5+html-reports-dev,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
 librust-cranelift-0.103+core-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/cargo/bin/cargo-auto-test cranelift 0.103.0
 --all-targets
Features: test-name=cranelift-0.103:default
Architecture: !armel !armhf !ppc64el !s390x
Depends:
 dh-cargo,
 librust-criterion-0.5+default-dev,
 librust-criterion-0.5+html-reports-dev,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
 librust-cranelift-0.103+default-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/cargo/bin/cargo-auto-test cranelift 0.103.0
 --all-targets --no-default-features --features std
Features: test-name=cranelift-0.103:std
Architecture: !armel !armhf !ppc64el !s390x
Depends:
 dh-cargo,
 librust-criterion-0.5+default-dev,
 librust-criterion-0.5+html-reports-dev,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
 librust-cranelift-0.103+std-dev,
Restrictions: allow-stderr

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

opts=\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-$1/,\
repacksuffix=+dfsg,\
dversionmangle=auto \
https://github.com/bytecodealliance/wasmtime/tags \
.*?@ANY_VERSION@@ARCHIVE_EXT@

## rust-wasmtime 19.0.0+dfsg

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -22,6 +22,9 @@
 
 	target_include_directories(wasmtime-${TARGET} PUBLIC wasmtime)
 	target_link_libraries(wasmtime-${TARGET} PUBLIC wasmtime)
+	if(APPLE)
+		target_link_libraries(wasmtime-${TARGET} PRIVATE "-framework CoreFoundation")
+	endif()
 	add_test(NAME ${TARGET}-c COMMAND $<TARGET_FILE:wasmtime-${TARGET}> WORKING_DIRECTORY ../..)
 endfunction()
 
@@ -59,6 +62,7 @@
 create_rust_wasm(fib-debug wasm32-unknown-unknown)
 create_rust_wasm(tokio wasm32-wasi)
 create_rust_wasm(wasi wasm32-wasi)
+create_rust_wasm(component wasm32-unknown-unknown)
 create_rust_test(epochs)
 create_rust_test(externref)
 create_rust_test(fib-debug)
@@ -73,4 +77,5 @@
 create_rust_test(serialize)
 create_rust_test(threads)
 create_rust_test(wasi)
-create_rust_test(tokio wasmtime-wasi/tokio)
+create_rust_test(tokio wasi-common/tokio)
+create_rust_test(component)

=== crates/c-api/CMakeLists.txt ===
--- 
+++ 
@@ -9,23 +9,6 @@
 	set(WASMTIME_BUILD_TYPE "release")
 else()
 	set(WASMTIME_BUILD_TYPE "debug")
-endif()
-
-if(BUILD_SHARED_LIBS)
-	# Copy shared library into build directory
-	if(WIN32)
-		set(WASMTIME_INSTALL_COMMAND ${CMAKE_COMMAND} -E copy_if_different
-			${CMAKE_CURRENT_SOURCE_DIR}/../../target/${WASMTIME_BUILD_TYPE}/wasmtime.dll
-			${CMAKE_BINARY_DIR})
-	elseif(APPLE)
-		set(WASMTIME_INSTALL_COMMAND ${CMAKE_COMMAND} -E copy_if_different
-			${CMAKE_CURRENT_SOURCE_DIR}/../../target/${WASMTIME_BUILD_TYPE}/libwasmtime.dylib
-			${CMAKE_BINARY_DIR})
-	else()
-		set(WASMTIME_INSTALL_COMMAND ${CMAKE_COMMAND} -E copy_if_different
-			${CMAKE_CURRENT_SOURCE_DIR}/../../target/${WASMTIME_BUILD_TYPE}/libwasmtime.so
-			${CMAKE_BINARY_DIR})
-	endif()
 endif()
 
 if(ANDROID)

=== debian/changelog ===
rust-wasmtime (19.0.0+dfsg-4) unstable; urgency=medium

  * tighten substvars: use ${rust:Version:*} with full package name
    (see bug#1076434)
  * autopkgtest-depend on dh-rust (not dh-cargo)
  * tighten build rules to catch failure in loop
  * stop mention dh-cargo in long description
  * add patch 2001_* to use newer release of crate regalloc2
  * check single-feature autopkgtest tests only on amd64

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 04 Nov 2024 22:15:53 +0100

rust-wasmtime (19.0.0+dfsg-3) unstable; urgency=medium

  * simplify packaging;
    build-depend on dh-sequence-rust
    (not dh-cargo libstring-shellquote-perl)

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 12 Jul 2024 19:55:46 +0200

rust-wasmtime (19.0.0+dfsg-2) unstable; urgency=medium

  * add patch 2001_target-lexicon
    to accept older release of crate target-lexicon

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 17 May 2024 13:56:14 +0200

rust-wasmtime (19.0.0+dfsg-1) unstable; urgency=medium

  * update copyright info:
    + fix file path
    + update coverage
  * drop patch 2001_hashbrown;
    tighten build-dependency on package for crate hashbrown
  * drop patch 2001_regalloc2
  * update and unfuzz patches
  * add patch 2003 to avoid benches;
    stop build- or autopkgtest-depend on packages for crates criterion
  * declare compliance with Debian Policy 4.7.0
  * drop patch 2001_gimli;
    tighten (build-)dependencies on package for crate gimli
  * bump project versions in virtual packages and autopkgtests

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 17 May 2024 09:15:33 +0200

rust-wasmtime (18.0.1+dfsg-1) experimental; urgency=medium

  [ upstream ]
  * new release(s)

  [ Jonas Smedegaard ]
  * bump project versions in virtual packages and autopkgtests
  * update and unfuzz patches

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 22 Feb 2024 18:38:48 +0100

=== debian/control ===
Source: rust-wasmtime
Section: rust
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-rust,
 librust-tempfile-3+default-dev <!nocheck>,
 librust-anyhow-1+default-dev <!nocheck>,
 librust-arbitrary-1+default-dev <!nocheck>,
 librust-bincode-1+default-dev <!nocheck>,
 librust-bumpalo-3+default-dev <!nocheck>,
 librust-capstone-0.11+default-dev <!nocheck>,
 librust-gimli-0.28+read-dev <!nocheck>,
 librust-gimli-0.28+std-dev <!nocheck>,
 librust-hashbrown-0.14-dev <!nocheck>,
 librust-log-0.4-dev <!nocheck>,
 librust-regalloc2-0.9+checker-dev <!nocheck>,
 librust-regalloc2-0.9+default-dev <!nocheck>,
 librust-serde-1+default-dev <!nocheck>,
 librust-serde-1+derive-dev <!nocheck>,
 librust-sha2-0.10+default-dev <!nocheck>,
 librust-similar-2+default-dev <!nocheck>,
 librust-smallvec-1+default-dev <!nocheck>,
 librust-smallvec-1+union-dev <!nocheck>,
 librust-souper-ir-2+default-dev <!nocheck>,
 librust-target-lexicon-0.12+std-dev (>= 0.12.12) <!nocheck>,
 rustfmt <!nocheck>,
Maintainer: Jonas Smedegaard <dr@jones.dk>
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/debian/rust-wasmtime.git
Vcs-Browser: https://salsa.debian.org/debian/rust-wasmtime
Homepage: https://wasmtime.dev/
Rules-Requires-Root: no

Package: librust-cranelift-dev
Architecture: all
Multi-Arch: foreign
Depends:
 librust-anyhow-1+default-dev,
 librust-arbitrary-1+default-dev,
 librust-bincode-1+default-dev,
 librust-bumpalo-3+default-dev,
 librust-capstone-0.11+default-dev,
 librust-codespan-reporting-0.11+default-dev,
 librust-gimli-0.28+read-dev,
 librust-gimli-0.28+std-dev,
 librust-hashbrown-0.14-dev,
 librust-log-0.4-dev,
 librust-regalloc2-0.9+checker-dev,
 librust-regalloc2-0.9+default-dev,
 librust-serde-1+default-dev,
 librust-serde-1+derive-dev,
 librust-sha2-0.10+default-dev,
 librust-smallvec-1+default-dev,
 librust-smallvec-1+union-dev,
 librust-souper-ir-2+default-dev,
 librust-target-lexicon-0.12+std-dev (>= 0.12.12),
 rustfmt,
 ${misc:Depends},
Provides:
 librust-cranelift-0.106+core-dev (= ${binary:Version}),
 librust-cranelift-0.106+default-dev (= ${binary:Version}),
 librust-cranelift-0.106+std-dev (= ${binary:Version}),
 librust-cranelift-0.106-dev (= ${binary:Version}),
 librust-cranelift-0.106.0-dev (= ${binary:Version}),
 librust-cranelift-bforest-0.106+default-dev (= ${rust:Version:librust-cranelift-bforest-dev}),
 librust-cranelift-bforest-0.106-dev (= ${rust:Version:librust-cranelift-bforest-dev}),
 librust-cranelift-bforest-0.106.0-dev (= ${rust:Version:librust-cranelift-bforest-dev}),
 librust-cranelift-codegen-0.106+default-dev (= ${rust:Version:librust-cranelift-codegen-dev}),
 librust-cranelift-codegen-0.106-dev (= ${rust:Version:librust-cranelift-codegen-dev}),
 librust-cranelift-codegen-0.106.0-dev (= ${rust:Version:librust-cranelift-codegen-dev}),
 librust-cranelift-codegen-meta-0.106+default-dev (= ${rust:Version:librust-cranelift-codegen-meta-dev}),
 librust-cranelift-codegen-meta-0.106-dev (= ${rust:Version:librust-cranelift-codegen-meta-dev}),
 librust-cranelift-codegen-meta-0.106.0-dev (= ${rust:Version:librust-cranelift-codegen-meta-dev}),
 librust-cranelift-codegen-shared-0.106+default-dev (= ${rust:Version:librust-cranelift-codegen-shared-dev}),
 librust-cranelift-codegen-shared-0.106-dev (= ${rust:Version:librust-cranelift-codegen-shared-dev}),
 librust-cranelift-codegen-shared-0.106.0-dev (= ${rust:Version:librust-cranelift-codegen-shared-dev}),
 librust-cranelift-control-0.106+chaos-dev (= ${rust:Version:librust-cranelift-control-dev}),
 librust-cranelift-control-0.106+default-dev (= ${rust:Version:librust-cranelift-control-dev}),
 librust-cranelift-control-0.106-dev (= ${rust:Version:librust-cranelift-control-dev}),
 librust-cranelift-control-0.106.0-dev (= ${rust:Version:librust-cranelift-control-dev}),
 librust-cranelift-entity-0.106+default-dev (= ${rust:Version:librust-cranelift-entity-dev}),
 librust-cranelift-entity-0.106+enable-serde-dev (= ${rust:Version:librust-cranelift-entity-dev}),
 librust-cranelift-entity-0.106-dev (= ${rust:Version:librust-cranelift-entity-dev}),
 librust-cranelift-entity-0.106.0-dev (= ${rust:Version:librust-cranelift-entity-dev}),
 librust-cranelift-frontend-0.106+core-dev (= ${rust:Version:librust-cranelift-frontend-dev}),
 librust-cranelift-frontend-0.106+default-dev (= ${rust:Version:librust-cranelift-frontend-dev}),
 librust-cranelift-frontend-0.106+std-dev (= ${rust:Version:librust-cranelift-frontend-dev}),
 librust-cranelift-frontend-0.106-dev (= ${rust:Version:librust-cranelift-frontend-dev}),
 librust-cranelift-frontend-0.106.0-dev (= ${rust:Version:librust-cranelift-frontend-dev}),
 librust-cranelift-isle-0.106+default-dev (= ${rust:Version:librust-cranelift-isle-dev}),
 librust-cranelift-isle-0.106+logging-dev (= ${rust:Version:librust-cranelift-isle-dev}),
 librust-cranelift-isle-0.106+fancy-errors-dev (= ${rust:Version:librust-cranelift-isle-dev}),
 librust-cranelift-isle-0.106-dev (= ${rust:Version:librust-cranelift-isle-dev}),
 librust-cranelift-isle-0.106.0-dev (= ${rust:Version:librust-cranelift-isle-dev}),
Description: low-level retargetable code generator - Rust source code
 Cranelift is a low-level retargetable code generator.
 It translates a target-independent intermediate representation
 into executable machine code.
 .
 This package contains the source for the Rust cranelift crate,
 for use with cargo.

=== debian/rules ===
#!/usr/bin/make -f

# resolve DEB_VERSION
include /usr/share/dpkg/pkg-info.mk

# resolve crate version
# * get topmost version except prerelease suffix
#   from Cargo.toml file in dir passed as argument
# * source package version if matching upstream part modulo prerelease
# * otherwise append source package version
crate_version = \
 $(shell perl -n \
 -E '/version\W+\K\d+\.\d+\.\d+/ ' \
 -E 'and say "$(DEB_VERSION_UPSTREAM)" =~ /^\Q$$&\E(?:~[a-z]+\d*)?$$/ ? "$(DEB_VERSION)" : "$$&+$(DEB_VERSION_UPSTREAM_REVISION)" and exit' \
 $1/Cargo.toml)

%:
	dh $@ --sourcedirectory cranelift/umbrella

# unlock dependencies during build
execute_before_dh_auto_configure:
	[ -f Cargo.lock.orig ] || mv Cargo.lock Cargo.lock.orig

override_dh_gencontrol:
	dh_gencontrol -plibrust-cranelift-dev -- -v'$(call crate_version,cranelift/umbrella)'
	dh_gencontrol --remaining-packages
# declare version for virtually provided embedded crates
packages = librust-cranelift-dev
vpkgstems = bforest codegen codegen-meta codegen-shared control entity frontend isle
packages_virtual = $(patsubst %,librust-cranelift-%-dev,$(vpkgstems))
override_dh_gencontrol:
	$(eval librust-cranelift-dev_version = $(call crate_version,cranelift/umbrella))\
	$(foreach s,$(vpkgstems),\
	 $(eval librust-cranelift-$s-dev_version = $(call crate_version,cranelift/$(subst isle,isle/isle,$(subst -,/,$s)))))\
	set -e; $(foreach p,$(packages),\
	 dh_gencontrol -p$p -- \
	 -v'$($p_version)' \
	 $(foreach q,$(filter-out $p,$(packages) $(packages_virtual)),\
	 -V'rust:Version:$q=$($q_version)');)
	dh_gencontrol --remaining-packages

# avoid cleaning unless source is patched
override_dh_auto_clean:
	grep -q crates/wasi-common/WASI/ Cargo.toml || dh_auto_clean --buildsystem rust

# re-lock dependencies
execute_after_dh_auto_clean:
	[ ! -f Cargo.lock.orig ] || mv -f Cargo.lock.lock Cargo.lock

=== debian/tests/control ===
# check single-feature tests only on amd64
# skip official architectures unsupported by crate cranelift-codegen

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test cranelift 0.106.0
 --all-targets --all-features
Features: test-name=cranelift:@
Architecture: !armel !armhf !ppc64el !s390x
Depends:
 dh-rust,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
 librust-cranelift-0.106-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test cranelift 0.106.0
 --all-targets
Features: test-name=cranelift:default
Architecture: !armel !armhf !ppc64el !s390x
Depends:
 dh-rust,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
 librust-cranelift-0.106+default-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test cranelift 0.106.0
 --all-targets --no-default-features
Features: test-name=cranelift:
Architecture: !armel !armhf !ppc64el !s390x
Depends:
 dh-rust,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
 librust-cranelift-0.106-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test cranelift 0.106.0
 --all-targets --no-default-features --features core
Features: test-name=cranelift:core
Architecture: amd64
#Architecture: !armel !armhf !ppc64el !s390x
Depends:
 dh-rust,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
 librust-cranelift-0.106+core-dev,
Restrictions: allow-stderr

Test-Command: /usr/share/dh-rust/bin/cargo-auto-test cranelift 0.106.0
 --all-targets --no-default-features --features std
Features: test-name=cranelift:std
Architecture: amd64
#Architecture: !armel !armhf !ppc64el !s390x
Depends:
 dh-rust,
 librust-similar-2+default-dev,
 librust-tempfile-3+default-dev,
 librust-cranelift-0.106+std-dev,
Restrictions: allow-stderr
